diff -BbuprN tbamud-3.55/src/genshp.c tbamud-3.55+quests/src/genshp.c
--- tbamud-3.55/src/genshp.c	2008-01-16 23:21:16.000000000 +0000
+++ tbamud-3.55+quests/src/genshp.c	2008-01-31 12:19:27.256922000 +0000
@@ -24,6 +24,9 @@ void copy_shop_type_list(struct shop_buy
 void free_shop_strings(struct shop_data *shop);
 void free_shop_type_list(struct shop_buy_data **list);
 
+/* External Functions */
+void create_world_index(int znum, const char *type);
+
 void copy_shop(struct shop_data *tshop, struct shop_data *fshop, int free_old_strings)
 {
   /* Copy basic information over. */
@@ -343,7 +346,7 @@ int add_shop(struct shop_data *nshp)
 
 int save_shops(zone_rnum zone_num)
 {
-  int i, j, rshop;
+  int i, j, rshop, num_shops = 0;
   FILE *shop_file;
   char fname[128], oldname[128];
   struct shop_data *shop;
@@ -424,6 +427,7 @@ int save_shops(zone_rnum zone_num)
       /* Save open/closing times. */
       fprintf(shop_file, "%d\n%d\n%d\n%d\n", S_OPEN1(shop), S_CLOSE1(shop),
 		S_OPEN2(shop), S_CLOSE2(shop));
+      num_shops++;
     }
   }
   fprintf(shop_file, "$~\n");
@@ -432,6 +436,9 @@ int save_shops(zone_rnum zone_num)
   remove(oldname);
   rename(fname, oldname);
 
+  if (num_shops > 0)
+    create_world_index(zone_table[zone_num].number, "shp");
+
   if (in_save_list(zone_table[zone_num].number, SL_SHP))
     remove_from_save_list(zone_table[zone_num].number, SL_SHP);
   return TRUE;
diff -BbuprN tbamud-3.55/src/genzon.c tbamud-3.55+quests/src/genzon.c
--- tbamud-3.55/src/genzon.c	2008-01-16 23:21:14.000000000 +0000
+++ tbamud-3.55+quests/src/genzon.c	2008-01-31 09:36:08.069422000 +0000
@@ -134,6 +134,16 @@ zone_rnum create_new_zone(zone_vnum vzon
   fprintf(fp, "$~\n");
   fclose(fp);
 
+   /* Create the quests file */
+  snprintf(buf, sizeof(buf), "%s/%d.qst", QST_PREFIX, vzone_num);
+  if (!(fp = fopen(buf, "w"))) {
+    mudlog(BRF, LVL_IMPL, TRUE, "SYSERR: OLC: Can't write new quest file");
+    *error = "Could not write quest file.\r\n";
+    return NOWHERE;
+  }
+  fprintf(fp, "$~\n");
+  fclose(fp);
+
   /* Update index files. */
   create_world_index(vzone_num, "zon");
   create_world_index(vzone_num, "wld");
@@ -141,6 +151,7 @@ zone_rnum create_new_zone(zone_vnum vzon
   create_world_index(vzone_num, "obj");
   create_world_index(vzone_num, "shp");
   create_world_index(vzone_num, "trg");
+  create_world_index(vzone_num, "qst");
 
   /* Make a new zone in memory. This was the source of all the zedit new 
    * crashes. It was happily overwriting the stack.  This new loop by Andrew 
@@ -212,6 +223,9 @@ void create_world_index(int znum, const 
   case 't':
     prefix = TRG_PREFIX;
     break;
+  case 'q':
+    prefix = QST_PREFIX;
+    break;
   default:
     /* Caller messed up. */
     return;
@@ -242,6 +256,12 @@ void create_world_index(int znum, const 
       if (num > znum) {
 	found = TRUE;
 	fprintf(newfile, "%s\n", buf1);
+      } else if (num == znum) {
+        /* index file already had an entry for this zone. */
+        fclose(oldfile);
+        fclose(newfile);
+        remove(new_name);
+        return;
       }
     }
     fprintf(newfile, "%s\n", buf);
diff -BbuprN tbamud-3.55/src/handler.c tbamud-3.55+quests/src/handler.c
--- tbamud-3.55/src/handler.c	2008-01-16 23:21:16.000000000 +0000
+++ tbamud-3.55+quests/src/handler.c	2008-01-31 09:38:02.944422000 +0000
@@ -18,6 +18,7 @@
 #include "interpreter.h"
 #include "spells.h"
 #include "dg_scripts.h"
+#include "quest.h"
 
 /* local vars */
 int extractions_pending = 0;
@@ -412,6 +413,9 @@ void char_to_room(struct char_data *ch, 
     world[room].people = ch;
     IN_ROOM(ch) = room;
 
+    autoquest_trigger_check(ch, 0, 0, AQ_ROOM_FIND);
+    autoquest_trigger_check(ch, 0, 0, AQ_MOB_FIND);
+
     if (GET_EQ(ch, WEAR_LIGHT))
       if (GET_OBJ_TYPE(GET_EQ(ch, WEAR_LIGHT)) == ITEM_LIGHT)
 	if (GET_OBJ_VAL(GET_EQ(ch, WEAR_LIGHT), 2))	/* Light ON */
@@ -436,6 +440,8 @@ void obj_to_char(struct obj_data *object
     IS_CARRYING_W(ch) += GET_OBJ_WEIGHT(object);
     IS_CARRYING_N(ch)++;
 
+    autoquest_trigger_check(ch, NULL, object, AQ_OBJ_FIND);
+
     /* set flag for crash-save system, but not on mobs! */
     if (!IS_NPC(ch))
       SET_BIT_AR(PLR_FLAGS(ch), PLR_CRASH);
diff -BbuprN tbamud-3.55/src/interpreter.c tbamud-3.55+quests/src/interpreter.c
--- tbamud-3.55/src/interpreter.c	2008-01-16 23:27:40.000000000 +0000
+++ tbamud-3.55+quests/src/interpreter.c	2008-01-31 09:45:06.788172000 +0000
@@ -26,6 +26,7 @@
 #include "improved-edit.h"
 #include "dg_scripts.h"
 #include "constants.h"
+#include "quest.h"
 
 /* external variables */
 extern room_rnum r_mortal_start_room;
@@ -164,6 +165,7 @@ ACMD(do_practice);
 ACMD(do_purge);
 ACMD(do_put);
 ACMD(do_qcomm);
+ACMD(do_quest);
 ACMD(do_quit);
 ACMD(do_reboot);
 ACMD(do_remove);
@@ -397,9 +399,11 @@ cpp_extern const struct command_info cmd
   { "prompt"   , "pro"     , POS_DEAD    , do_display  , 0, 0 },
   { "purge"    , "purge"   , POS_DEAD    , do_purge    , LVL_BUILDER, 0 },
 
+  { "qedit"    , "qedit"   , POS_DEAD    , do_oasis_qedit, LVL_BUILDER, 0 },
+  { "qlist"    , "qlist"   , POS_DEAD    , do_oasis_list, LVL_BUILDER, SCMD_OASIS_QLIST },
   { "quaff"    , "qua"     , POS_RESTING , do_use      , 0, SCMD_QUAFF },
   { "qecho"    , "qec"     , POS_DEAD    , do_qcomm    , LVL_GOD, SCMD_QECHO },
-  { "quest"    , "que"     , POS_DEAD    , do_gen_tog  , 0, SCMD_QUEST },
+  { "quest"    , "que"	   , POS_DEAD    , do_quest    , 0, 0 },
   { "qui"      , "qui"     , POS_DEAD    , do_quit     , 0, 0 },
   { "quit"     , "quit"    , POS_DEAD    , do_quit     , 0, SCMD_QUIT },
   { "qsay"     , "qsay"    , POS_RESTING , do_qcomm    , 0, SCMD_QSAY },
@@ -1309,6 +1313,7 @@ void nanny(struct descriptor_data *d, ch
     { CON_TRIGEDIT, trigedit_parse },
     { CON_AEDIT, aedit_parse },
     { CON_HEDIT,    hedit_parse },
+    { CON_QEDIT, qedit_parse },
     { -1, NULL }
   };
 
diff -BbuprN tbamud-3.55/src/interpreter.h tbamud-3.55+quests/src/interpreter.h
--- tbamud-3.55/src/interpreter.h	2008-01-16 23:21:16.000000000 +0000
+++ tbamud-3.55+quests/src/interpreter.h	2008-01-31 09:45:31.600672000 +0000
@@ -219,6 +219,7 @@ struct alias_data {
 #define SCMD_OASIS_SLIST       3
 #define SCMD_OASIS_ZLIST       4
 #define SCMD_OASIS_TLIST       5
+#define SCMD_OASIS_QLIST       6
 
 /* do_last */
 #define SCMD_LIST_ALL 1
diff -BbuprN tbamud-3.55/src/modify.c tbamud-3.55+quests/src/modify.c
--- tbamud-3.55/src/modify.c	2008-01-16 23:21:16.000000000 +0000
+++ tbamud-3.55+quests/src/modify.c	2008-01-31 10:12:06.147547000 +0000
@@ -21,6 +21,7 @@
 #include "boards.h"
 #include "improved-edit.h"
 #include "oasis.h"
+#include "quest.h"
 
 void show_string(struct descriptor_data *d, char *input);
 
@@ -151,6 +152,7 @@ void string_add(struct descriptor_data *
         case CON_PLR_DESC:
         case CON_TRIGEDIT:
         case CON_HEDIT:
+        case CON_QEDIT:
 	  free(*d->str);
           *d->str = d->backstr;
           d->backstr = NULL;
@@ -190,6 +192,7 @@ void string_add(struct descriptor_data *
       { CON_PLR_DESC , exdesc_string_cleanup },
       { CON_PLAYING, playing_string_cleanup },
       { CON_HEDIT, hedit_string_cleanup },
+      { CON_QEDIT  , qedit_string_cleanup },
       { -1, NULL }
     };
 
diff -BbuprN tbamud-3.55/src/oasis.c tbamud-3.55+quests/src/oasis.c
--- tbamud-3.55/src/oasis.c	2008-01-16 23:21:16.000000000 +0000
+++ tbamud-3.55+quests/src/oasis.c	2008-01-31 10:14:25.725672000 +0000
@@ -22,6 +22,7 @@
 #include "oasis.h"
 #include "screen.h"
 #include "dg_olc.h"
+#include "quest.h"
 
 /* External Functions */
 int is_name(const char *str, const char *namelist);
@@ -40,6 +41,7 @@ struct olc_scmd_info_t {
   { "trigger",  CON_TRIGEDIT },
   { "action",   CON_AEDIT },
   { "help",     CON_HEDIT },
+  { "quest",     CON_QEDIT },
   { "\n",	-1	  }
 };
 
@@ -125,6 +127,20 @@ void cleanup_olc(struct descriptor_data 
   if (OLC_SHOP(d))
       free_shop(OLC_SHOP(d));
 
+  /* Check for a quest. */
+  if (OLC_QUEST(d)) {
+    switch (cleanup_type) {
+      case CLEANUP_ALL:
+        free_quest(OLC_QUEST(d));
+        break;
+      case CLEANUP_STRUCTS:
+        free(OLC_QUEST(d));
+        break;
+      default:
+        break;
+    }
+  }
+
   /*. Check for aedit stuff -- M. Scott */
   if (OLC_ACTION(d))  {
     switch(cleanup_type)  {
diff -BbuprN tbamud-3.55/src/oasis.h tbamud-3.55+quests/src/oasis.h
--- tbamud-3.55/src/oasis.h	2008-01-16 23:21:16.000000000 +0000
+++ tbamud-3.55+quests/src/oasis.h	2008-01-31 10:18:25.444422000 +0000
@@ -25,7 +25,7 @@
 #define NUM_ATTACK_TYPES	15
 
 #define NUM_ITEM_TYPES		24
-#define NUM_ITEM_FLAGS		17
+#define NUM_ITEM_FLAGS		18
 #define NUM_ITEM_WEARS 		15
 #define NUM_APPLIES		25
 #define NUM_LIQ_TYPES 		16
@@ -101,6 +101,7 @@ struct oasis_olc_data {
   struct zone_data *zone;        /* used for 'zedit'         */
   struct shop_data *shop;        /* used for 'sedit'         */
   struct config_data *config;    /* used for 'cedit'         */
+  struct aq_data *quest;         /* used for 'qedit'         */
   struct extra_descr_data *desc; /* used in '[r|o|m]edit'    */
   struct social_messg *action;   /* Aedit uses this one      */
   struct trig_data *trig;
@@ -130,6 +131,7 @@ extern const char *nrm, *grn, *cyn, *yel
 #define OLC_DESC(d) 	(OLC(d)->desc)		/* Extra description.	*/
 #define OLC_CONFIG(d)	(OLC(d)->config)	/* Config structure.	*/
 #define OLC_TRIG(d)     (OLC(d)->trig)          /* Trigger structure.   */
+#define OLC_QUEST(d)    (OLC(d)->quest)         /* Quest structure      */
 
 #define OLC_ACTION(d)   (OLC(d)->action)        /* Action structure     */
 #define OLC_HELP(d)     (OLC(d)->help)          /* Hedit structure      */
@@ -416,6 +418,8 @@ ACMD(do_oasis_hedit);
 void tedit_string_cleanup(struct descriptor_data *d, int terminator);
 ACMD(do_tedit);
 
+ACMD(do_oasis_qedit);
+
 /* oasis_delete.c */
 int free_strings(void *data, int type);
 
diff -BbuprN tbamud-3.55/src/oasis_list.c tbamud-3.55+quests/src/oasis_list.c
--- tbamud-3.55/src/oasis_list.c	2008-01-16 23:21:16.000000000 +0000
+++ tbamud-3.55+quests/src/oasis_list.c	2008-01-31 12:25:49.335047000 +0000
@@ -21,6 +21,7 @@
 #include "screen.h"
 #include "constants.h"
 #include "dg_scripts.h"
+#include "quest.h"
 
 /* local functions */
 void list_triggers(struct char_data *ch, zone_rnum rnum, trig_vnum vmin, trig_vnum vmax);
@@ -67,6 +68,7 @@ ACMD(do_oasis_list)
     case SCMD_OASIS_RLIST: list_rooms(ch, rzone, vmin, vmax); break;
     case SCMD_OASIS_TLIST: list_triggers(ch, rzone, vmin, vmax); break;
     case SCMD_OASIS_SLIST: list_shops(ch, rzone, vmin, vmax); break;
+    case SCMD_OASIS_QLIST: list_quests(ch, rzone, vmin, vmax); break;
     case SCMD_OASIS_ZLIST:
       if (!*smin)
         list_zones(ch, NOWHERE, 0, zone_table[top_of_zone_table].number);
@@ -349,7 +351,7 @@ void list_zones(struct char_data *ch, zo
 void print_zone(struct char_data *ch, zone_vnum vnum)
 {
   zone_rnum rnum;
-  int size_rooms, size_objects, size_mobiles, i;
+  int size_rooms, size_objects, size_mobiles, size_quests, i;
   room_vnum top, bottom;
   int largest_table;
 
@@ -370,6 +372,7 @@ void print_zone(struct char_data *ch, zo
   size_rooms   = 0;
   size_objects = 0;
   size_mobiles = 0;
+  size_quests  = 0;
   top          = zone_table[rnum].top;
   bottom       = zone_table[rnum].bot;
 
@@ -386,6 +389,7 @@ void print_zone(struct char_data *ch, zo
       if (mob_index[i].vnum >= bottom && mob_index[i].vnum <= top)
         size_mobiles++;
   }
+  size_quests = count_quests(bottom, top);
 
   /* Display all of the zone information at once. */
   send_to_char(ch,
@@ -400,7 +404,8 @@ void print_zone(struct char_data *ch, zo
     "%sSize\r\n"
     "%s   Rooms       = %s%d\r\n"
     "%s   Objects     = %s%d\r\n"
-    "%s   Mobiles     = %s%d%s\r\n",
+    "%s   Mobiles     = %s%d\r\n"
+    "%s   Quests      = %s%d%s\r\n",
     QGRN, QCYN, zone_table[rnum].number,
     QGRN, QCYN, zone_table[rnum].name,
     QGRN, QCYN, zone_table[rnum].builders,
@@ -413,7 +418,8 @@ void print_zone(struct char_data *ch, zo
     QGRN,
     QGRN, QCYN, size_rooms,
     QGRN, QCYN, size_objects,
-    QGRN, QCYN, size_mobiles, QNRM);
+    QGRN, QCYN, size_mobiles,
+    QGRN, QCYN, size_quests, QNRM);
 }
 
 /* List code by Ronald Evers. */
diff -BbuprN tbamud-3.55/src/pfdefaults.h tbamud-3.55+quests/src/pfdefaults.h
--- tbamud-3.55/src/pfdefaults.h	2008-01-16 23:21:16.000000000 +0000
+++ tbamud-3.55+quests/src/pfdefaults.h	2008-01-31 10:23:37.491297000 +0000
@@ -51,6 +51,9 @@
 #define PFDEF_OLC               NOWHERE 
 #define PFDEF_PAGELENGTH        22
 #define PFDEF_QUESTPOINTS       0
+#define PFDEF_QUESTCOUNT        0
+#define PFDEF_COMPQUESTS        0
+#define PFDEF_CURRQUEST         NOTHING
 
 #endif
 
diff -BbuprN tbamud-3.55/src/players.c tbamud-3.55+quests/src/players.c
--- tbamud-3.55/src/players.c	2008-01-16 23:21:14.000000000 +0000
+++ tbamud-3.55+quests/src/players.c	2008-01-31 12:23:52.022547000 +0000
@@ -18,6 +18,7 @@
 #include "dg_scripts.h"
 #include "comm.h"
 #include "interpreter.h"
+#include "quest.h"
 
 #define LOAD_HIT	0
 #define LOAD_MANA	1
@@ -30,6 +31,7 @@ int sprintascii(char *out, bitvector_t b
 void tag_argument(char *argument, char *tag);
 void load_affects(FILE *fl, struct char_data *ch);
 void load_skills(FILE *fl, struct char_data *ch);
+void load_quests(FILE *fl, struct char_data *ch);
 void load_HMVS(struct char_data *ch, const char *line, int mode);
 void write_aliases_ascii(FILE *file, struct char_data *ch);
 void read_aliases_ascii(FILE *file, struct char_data *ch, int count);
@@ -264,6 +266,9 @@ int load_char(const char *name, struct c
     SITTING(ch) = NULL;
     NEXT_SITTING(ch) = NULL;
     GET_QUESTPOINTS(ch) = PFDEF_QUESTPOINTS;
+    GET_QUEST_COUNTER(ch) = PFDEF_QUESTCOUNT;
+    GET_QUEST(ch) = PFDEF_CURRQUEST;
+    GET_NUM_QUESTS(ch) = PFDEF_COMPQUESTS;
 
     for (i = 0; i < AF_ARRAY_MAX; i++)
       AFF_FLAGS(ch)[i] = PFDEF_AFFFLAGS;
@@ -387,6 +392,10 @@ int load_char(const char *name, struct c
 
       case 'Q':
 	     if (!strcmp(tag, "Qstp"))  GET_QUESTPOINTS(ch)     = atoi(line);
+    else if (!strcmp(tag, "Qpnt")) GET_QUESTPOINTS(ch) = atoi(line); /* Backward compatibility */
+    else if (!strcmp(tag, "Qcur")) GET_QUEST(ch) = atoi(line);
+	else if (!strcmp(tag, "Qcnt")) GET_QUEST_COUNTER(ch) = atoi(line);
+	else if (!strcmp(tag, "Qest")) load_quests(fl, ch);
         break;
 
       case 'R':
@@ -599,6 +608,14 @@ void save_char(struct char_data * ch)
   if (GET_OLC_ZONE(ch)     != PFDEF_OLC)        fprintf(fl, "Olc : %d\n", GET_OLC_ZONE(ch));
   if (GET_PAGE_LENGTH(ch)  != PFDEF_PAGELENGTH) fprintf(fl, "Page: %d\n", GET_PAGE_LENGTH(ch));
   if (GET_QUESTPOINTS(ch)  != PFDEF_QUESTPOINTS) fprintf(fl, "Qstp: %d\n", GET_QUESTPOINTS(ch));
+  if (GET_QUEST_COUNTER(ch)!= PFDEF_QUESTCOUNT)  fprintf(fl, "Qcnt: %d\n", GET_QUEST_COUNTER(ch));
+  if (GET_NUM_QUESTS(ch)   != PFDEF_COMPQUESTS) {
+    fprintf(fl, "Qest:\n");
+    for (i = 0; i < GET_NUM_QUESTS(ch); i++)
+      fprintf(fl, "%d\n", ch->player_specials->saved.completed_quests[i]);
+    fprintf(fl, "%d\n", NOTHING);
+  }
+  if (GET_QUEST(ch)        != PFDEF_CURRQUEST)  fprintf(fl, "Qcur: %d\n", GET_QUEST(ch));
 
   /* Save skills */
   if (GET_LEVEL(ch) < LVL_IMMORT) {
@@ -790,6 +807,19 @@ void load_skills(FILE *fl, struct char_d
   } while (num != 0);
 }
 
+void load_quests(FILE *fl, struct char_data *ch)
+{
+  int num = NOTHING;
+  char line[MAX_INPUT_LENGTH + 1];
+
+  do {
+    get_line(fl, line);
+    sscanf(line, "%d", &num);
+    if (num != NOTHING)
+      add_completed_quest(ch, num);
+  } while (num != NOTHING);
+}
+
 void load_HMVS(struct char_data *ch, const char *line, int mode)
 {
   int num = 0, num2 = 0;
